'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _getIterator2 = require('babel-runtime/core-js/get-iterator');

var _getIterator3 = _interopRequireDefault(_getIterator2);

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _koaRouter = require('koa-router');

var _koaRouter2 = _interopRequireDefault(_koaRouter);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var _marked = [runQuery, getCollections].map(_regenerator2.default.mark);

var Promise = require("bluebird");

var mime = require('mime');

var grid = require('gridfs-stream');
Promise.promisifyAll(grid);

var mongodb = require('mongodb');
var Db = mongodb.Db;
var Server = mongodb.Server;
var objectId = mongodb.ObjectId;

var MongoDB = require("mongodb");
Promise.promisifyAll(MongoDB);
var MongoClient = MongoDB.MongoClient;

var router = new _koaRouter2.default();

var formatQuery = function formatQuery(query) {
  if (query.indexOf('find') !== -1) {
    return query + '.toArray()';
  }
  return query;
};

router.get('/', _regenerator2.default.mark(function _callee() {
  return _regenerator2.default.wrap(function _callee$(_context) {
    while (1) {
      switch (_context.prev = _context.next) {
        case 0:
          _context.next = 2;
          return this.render('index');

        case 2:
        case 'end':
          return _context.stop();
      }
    }
  }, _callee, this);
}));

function runQuery(query, db) {
  var result;
  return _regenerator2.default.wrap(function runQuery$(_context2) {
    while (1) {
      switch (_context2.prev = _context2.next) {
        case 0:
          _context2.prev = 0;
          _context2.next = 3;
          return db.evalAsync(query);

        case 3:
          result = _context2.sent;
          return _context2.abrupt('return', { query: query, result: result });

        case 7:
          _context2.prev = 7;
          _context2.t0 = _context2['catch'](0);
          return _context2.abrupt('return', { query: query, err: _context2.t0 });

        case 10:
        case 'end':
          return _context2.stop();
      }
    }
  }, _marked[0], this, [[0, 7]]);
}

router.post('/api/query', _regenerator2.default.mark(function _callee2() {
  var body, host, activeDb, newUrl, connectionString, queries, results, db, _iteratorNormalCompletion, _didIteratorError, _iteratorError, _iterator, _step, query;

  return _regenerator2.default.wrap(function _callee2$(_context3) {
    while (1) {
      switch (_context3.prev = _context3.next) {
        case 0:
          body = this.request.body;
          host = body.host;
          activeDb = body.activeDb;
          newUrl = host.url.indexOf("mongodb://") === -1 ? 'mongodb://' + host.url : host.url;
          connectionString = newUrl + ':' + host.port + '/' + activeDb;
          queries = body.query.split(';');
          results = [];
          _context3.next = 9;
          return MongoClient.connectAsync(connectionString);

        case 9:
          db = _context3.sent;
          _iteratorNormalCompletion = true;
          _didIteratorError = false;
          _iteratorError = undefined;
          _context3.prev = 13;
          _iterator = (0, _getIterator3.default)(queries);

        case 15:
          if (_iteratorNormalCompletion = (_step = _iterator.next()).done) {
            _context3.next = 27;
            break;
          }

          query = _step.value;

          if (!(!query || query.trim() === '')) {
            _context3.next = 19;
            break;
          }

          return _context3.abrupt('continue', 24);

        case 19:
          _context3.t0 = results;
          _context3.next = 22;
          return runQuery(query, db);

        case 22:
          _context3.t1 = _context3.sent;

          _context3.t0.push.call(_context3.t0, _context3.t1);

        case 24:
          _iteratorNormalCompletion = true;
          _context3.next = 15;
          break;

        case 27:
          _context3.next = 33;
          break;

        case 29:
          _context3.prev = 29;
          _context3.t2 = _context3['catch'](13);
          _didIteratorError = true;
          _iteratorError = _context3.t2;

        case 33:
          _context3.prev = 33;
          _context3.prev = 34;

          if (!_iteratorNormalCompletion && _iterator.return) {
            _iterator.return();
          }

        case 36:
          _context3.prev = 36;

          if (!_didIteratorError) {
            _context3.next = 39;
            break;
          }

          throw _iteratorError;

        case 39:
          return _context3.finish(36);

        case 40:
          return _context3.finish(33);

        case 41:
          _context3.next = 43;
          return Promise.all(results);

        case 43:

          db.closeAsync();

          this.body = results;

        case 45:
        case 'end':
          return _context3.stop();
      }
    }
  }, _callee2, this, [[13, 29, 33, 41], [34,, 36, 40]]);
}));

function getCollections(database, db) {
  return _regenerator2.default.wrap(function getCollections$(_context4) {
    while (1) {
      switch (_context4.prev = _context4.next) {
        case 0:
          _context4.next = 2;
          return db.db(database.name).listCollections().toArray();

        case 2:
          database.collections = _context4.sent;
          return _context4.abrupt('return', database);

        case 4:
        case 'end':
          return _context4.stop();
      }
    }
  }, _marked[1], this);
}

router.post('/api/databases', _regenerator2.default.mark(function _callee3() {
  var body, url, port, newUrl, db, adminDb, dbs, databases, _iteratorNormalCompletion2, _didIteratorError2, _iteratorError2, _iterator2, _step2, database;

  return _regenerator2.default.wrap(function _callee3$(_context5) {
    while (1) {
      switch (_context5.prev = _context5.next) {
        case 0:
          body = this.request.body;
          url = body.url;
          port = body.port;
          newUrl = url.indexOf("mongodb://") === -1 ? 'mongodb://' + url : url;
          _context5.prev = 4;
          _context5.next = 7;
          return MongoClient.connectAsync(newUrl + ':' + port);

        case 7:
          db = _context5.sent;
          adminDb = db.admin();
          _context5.next = 11;
          return adminDb.listDatabasesAsync();

        case 11:
          dbs = _context5.sent;
          databases = [];
          _iteratorNormalCompletion2 = true;
          _didIteratorError2 = false;
          _iteratorError2 = undefined;
          _context5.prev = 16;
          _iterator2 = (0, _getIterator3.default)(dbs.databases);

        case 18:
          if (_iteratorNormalCompletion2 = (_step2 = _iterator2.next()).done) {
            _context5.next = 28;
            break;
          }

          database = _step2.value;
          _context5.t0 = databases;
          _context5.next = 23;
          return getCollections(database, db);

        case 23:
          _context5.t1 = _context5.sent;

          _context5.t0.push.call(_context5.t0, _context5.t1);

        case 25:
          _iteratorNormalCompletion2 = true;
          _context5.next = 18;
          break;

        case 28:
          _context5.next = 34;
          break;

        case 30:
          _context5.prev = 30;
          _context5.t2 = _context5['catch'](16);
          _didIteratorError2 = true;
          _iteratorError2 = _context5.t2;

        case 34:
          _context5.prev = 34;
          _context5.prev = 35;

          if (!_iteratorNormalCompletion2 && _iterator2.return) {
            _iterator2.return();
          }

        case 37:
          _context5.prev = 37;

          if (!_didIteratorError2) {
            _context5.next = 40;
            break;
          }

          throw _iteratorError2;

        case 40:
          return _context5.finish(37);

        case 41:
          return _context5.finish(34);

        case 42:
          _context5.next = 44;
          return Promise.all(databases);

        case 44:

          db.closeAsync();
          this.body = dbs;

          _context5.next = 52;
          break;

        case 48:
          _context5.prev = 48;
          _context5.t3 = _context5['catch'](4);

          console.dir(_context5.t3);
          this.throw(400, 'Error connecting to database');

        case 52:
        case 'end':
          return _context5.stop();
      }
    }
  }, _callee3, this, [[4, 48], [16, 30, 34, 42], [35,, 37, 41]]);
}));

router.get('/api/files/:url/:port/:database/:filename', _regenerator2.default.mark(function _callee4() {
  var _params, url, port, database, filename, mimetype, newUrl, gridDb, that, gfs;

  return _regenerator2.default.wrap(function _callee4$(_context6) {
    while (1) {
      switch (_context6.prev = _context6.next) {
        case 0:

          console.dir(this.params);
          _params = this.params;
          url = _params.url;
          port = _params.port;
          database = _params.database;
          filename = _params.filename;
          mimetype = mime.lookup(filename);
          newUrl = url.indexOf("mongodb://") !== -1 ? url.slice(10) : url;
          gridDb = new Db(database, new Server(newUrl, Number(port)));
          that = this;
          _context6.next = 12;
          return gridDb.openAsync();

        case 12:

          // TODO close gridDb
          gfs = grid(gridDb, mongodb);

          this.set('Content-type', mimetype);
          this.body = gfs.createReadStream({ filename: filename });

        case 15:
        case 'end':
          return _context6.stop();
      }
    }
  }, _callee4, this);
}));

exports.default = router.routes.bind(router);
//# sourceMappingURL=static.js.map